/* mni1r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    real teta, tet, e;
    integer nf, ng, m1, nu;
} mni1_;

#define mni1_1 mni1_

struct {
    real ex, eg, egr, e2, step, mg, mp;
    integer iu, iws, ie, kit;
    real gamma;
    integer n1, iwd;
} mni2_;

#define mni2_1 mni2_

/* Subroutine */ int mni1r_c(integer *n, real *x, real *a, real *b, integer *m,
         integer *l, real *f, real *fun, real *g, real *grad, real *up, 
        integer *i0, real *rm, integer *iw, S_fp mni)
{
    /* System generated locals */
    integer i__1;
    real r__1;

    /* Local variables */
    extern /* Subroutine */ int mni10_c(real *, real *, integer *, integer *,
             integer *, real *, real *, real *, real *, real *, real *, real *,
             integer *, real *, real *, real *, real *, S_fp),
            mni20_c(real *, integer *, integer *, integer *, real *,
             real *, real *, real *),
            mni30_c(integer *, integer *, integer *, integer *, real *, real *,
             real *),
            mni25_c(real *, integer *, integer *, integer *, real *, real *,
             real *, integer *, real *);
    static integer kmax;
    extern /* Subroutine */ int mnr1n_c(real *, integer *, real *),
            mnr1s_c(real *, real *, integer *, real *);
    static integer i__;
    static real t, e1;
    static integer k1, k2, k3, k4, k5;
    static real r1, r2, r3, r4;
    static integer k6, k7, ni;
    static real fs;
    static integer kp;
    static real fz, fx;
    static integer np, mg1, k4i, k5i, k7i, mp1, nit;

    /* Parameter adjustments */
    --g;
    --b;
    --a;
    --x;
    --f;
    --up;
    --i0;
    --rm;

    /* Function Body */
    mni1_1.nu = up[15];
    fz = 1e18f;
    if (*l > 1) {
        goto L1;
    }
    mni2_1.iws = 134;
    mni2_1.eg = up[8];
    mni2_1.ex = up[7];
    goto L2;
L1:
    mni1_1.e = up[2];
    mni2_1.egr = up[11];
    mni2_1.ex = up[12];
    mni2_1.eg = up[13];
    mni2_1.iwd = 1;
    mni2_1.iws = 1;
    mni1_1.teta = up[1];
    mni1_1.tet = mni1_1.teta - 1.f;
    mni2_1.e2 = 10.f;
L2:
    ni = 0;
    mni1_1.nf = 0;
    mni1_1.ng = 0;
    *iw = 0;
    mni2_1.iu = up[4];
    mni2_1.kit = up[5];
    kmax = up[14];
    np = up[9];
    kp = up[10];
    mni2_1.step = 1.f;
    k1 = (*n << 1) + 1;
/* Computing 2nd power */
    i__1 = *n;
    k2 = i__1 * i__1 + (*n << 1) + 1;
/* Computing 2nd power */
    i__1 = *n;
    k3 = (i__1 * i__1 << 1) + (*n << 1) + 1;
    k4 = k3 + *n * 5 - 1;
    k5 = k3 + *n * 6 - 1;
    k6 = k3 + *n * 7;
    k7 = k3 + *n - 1;
    mni2_1.n1 = *n - 1;
    mni1_1.m1 = *m + 1;
    mni2_1.gamma = 1e-10f;
    mni20_c(fun, n, m, l, &x[1], &fx, &f[1], &fs);
L4:
    mni25_c(grad, n, m, l, &x[1], &f[1], &g[1], &i0[1], &rm[k4 + 1]);
L5:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        k4i = k4 + i__;
        k5i = k5 + i__;
/* L10: */
        g[i__] = rm[k4i] + mni1_1.e * rm[k5i];
    }
    mnr1n_c(&g[1], n, &mni2_1.mg);
    fx = f[1] + mni1_1.e * fs;
/* L15: */
    mni2_1.ie = 0;
L16:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        if (x[i__] < a[i__] + mni2_1.ex && g[i__] > 0.f) {
            g[i__] = 0.f;
        }
        if (x[i__] > b[i__] - mni2_1.ex && g[i__] < 0.f) {
            g[i__] = 0.f;
        }
/* L18: */
    }
    mnr1n_c(&g[1], n, &mni2_1.mp);
    if (np != 0 || kp == 0 || ni != 0) {
        goto L20;
    }
    mni30_c(n, m, l, &ni, &x[1], &fx, &f[1]);
L20:
    if (mni2_1.mp <= mni2_1.gamma) {
        goto L77;
    }
L21:
    if (ni >= kmax) {
        goto L85;
    }
    mni2_1.iwd = mni2_1.iws;
    ++ni;
    mni10_c(fun, grad, n, m, l, &a[1], &b[1], &x[1], &fx, &f[1], &fs, &g[1],
            &i0[1], &rm[k1], &rm[k2], &rm[k3], &rm[k6], (S_fp)mni);
    if (ni < np || kp == 0 || (ni - np) % kp != 0) {
        goto L22;
    }
    mni30_c(n, m, l, &ni, &x[1], &fx, &f[1]);
L22:
    if (mni2_1.iws == 9) {
        goto L90;
    }
    if (*l > 1 || mni2_1.iws != 4) {
        goto L35;
    }
    mni2_1.iws = 134;
    goto L21;
L35:
    if (mni2_1.iws == 13) {
        goto L70;
    }
    if (mni2_1.iws == 5) {
        goto L77;
    }
    if (mni2_1.iws == 4) {
        goto L45;
    }
    if (fs <= mni2_1.egr) {
        goto L37;
    }
L36:
    if (mni2_1.kit == 1) {
        mni2_1.ex = mni2_1.step * .1f;
    }
    mni1_1.e *= up[3];
    goto L5;
L37:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L38: */
        rm[i__] = x[i__];
    }
L40:
    fz = fx;
    mni2_1.kit = up[5];
    mni2_1.iws = 134;
    goto L21;
L45:
    if (fz >= fx) {
        goto L50;
    }
/* Computing MAX */
    r__1 = mni2_1.e2 / 2.f;
    mni2_1.e2 = max(r__1,1.f);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        x[i__] = rm[i__];
        nit = *n + i__;
/* L46: */
        g[i__] = rm[nit];
    }
    fx = fz;
    mni2_1.mg = (real) mg1;
    mni2_1.mp = (real) mp1;
    mni2_1.iws = 134;
    goto L21;
L50:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        k4i = k4 + i__;
        k7i = k7 + i__;
        rm[k7i] = rm[k4i];
        nit = *n + i__;
        rm[nit] = x[i__] - rm[i__];
        if (x[i__] > a[i__] + mni2_1.ex) {
            goto L51;
        }
        k4i = k4 + i__;
        k7i = k7 + i__;
        if (rm[k4i] > 0.f) {
            rm[k7i] = 0.f;
        }
        nit = *n + i__;
        if (x[i__] < rm[i__]) {
            rm[nit] = 0.f;
        }
L51:
        if (x[i__] < b[i__] - mni2_1.ex) {
            goto L52;
        }
        k7i = k7 + i__;
        k4i = k4 + i__;
        if (rm[k4i] < 0.f) {
            rm[k7i] = 0.f;
        }
        nit = *n + i__;
        if (x[i__] > rm[i__]) {
            rm[nit] = 0.f;
        }
L52:
        ;
    }
    mnr1n_c(&rm[*n + 1], n, &r1);
    mnr1n_c(&rm[k7 + 1], n, &r2);
    t = 0.f;
    if (r2 <= mni2_1.gamma) {
        goto L37;
    }
L54:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        nit = *n + i__;
        k7i = k7 + i__;
/* L55: */
        rm[i__] = rm[nit] * (1 - t) / r1 - t * rm[k7i] / r2;
    }
    mnr1n_c(&rm[1], n, &r4);
    if (r4 <= mni2_1.gamma) {
        goto L57;
    }
    mnr1s_c(&rm[k7 + 1], &rm[1], n, &r3);
    r3 /= r4;
    if (r3 + mni2_1.gamma < 0.f) {
        goto L60;
    }
L57:
    t += .1f;
    goto L54;
L60:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        k7i = k7 + i__;
        rm[k7i] = rm[i__] / r4;
        nit = *n + i__;
        rm[nit] = g[i__];
/* L65: */
        rm[i__] = x[i__];
    }
    fz = fx;
    mp1 = mni2_1.mp;
    mg1 = mni2_1.mg;
    fx = f[1];
    mni2_1.iws = 4;
    e1 = mni1_1.e;
    mni1_1.e = 0.f;
    mni2_1.step = max(mni2_1.egr,mni2_1.step);
    (*mni)(fun, &a[1], &b[1], n, m, l, &rm[1], &fx, &f[1], &fs, &x[1],
            &rm[k7 + 1], &r3, &rm[k6]);
    mni1_1.e = e1;
    mni2_1.kit = up[5];
    mni2_1.iws = 134;
    goto L4;
L70:
    if (fs <= up[6] && mni2_1.step <= up[7]) {
        goto L76;
    }
    if (fs <= up[6]) {
        goto L75;
    }
L73:
    mni2_1.iws = 1;
    mni1_1.e *= up[3];
    mni2_1.e2 = 10.f;
    mni2_1.egr = min(1.f,fs) * .1f;
    goto L5;
L75:
    mni2_1.iws = 134;
    mni2_1.kit = up[5];
/* Computing MAX */
    r__1 = mni2_1.step * .1f;
    mni2_1.ex = max(r__1,up[7]);
    goto L16;
L76:
    if (mni2_1.mp <= up[8]) {
        goto L80;
    }
/* Computing MAX */
    r__1 = mni2_1.mp * .1f;
    mni2_1.eg = max(r__1,up[8]);
    goto L40;
L77:
    if (fs > up[6]) {
        goto L78;
    }
    goto L80;
L78:
    if (mni2_1.iwd == 134) {
        goto L73;
    }
    mni2_1.iws = 1;
    goto L36;
L80:
    *iw = 1;
    goto L90;
L85:
    *iw = 4;
L90:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        k4i = k4 + i__;
/* L95: */
        g[i__] = rm[k4i];
    }
    if (kp == 0 || ni >= np && (ni - np) % kp == 0) {
        goto L100;
    }
    mni30_c(n, m, l, &ni, &x[1], &fx, &f[1]);
L100:
    rm[1] = (real) ni;
    rm[2] = (real) mni1_1.nf;
    rm[3] = (real) mni1_1.ng;
    return 0;
} /* mni1r_c */
